// modules are defined as an array
// [ module function, map of requires ]
//
// map of requires is short require name -> numeric require
//
// anything defined in a previous bundle is accessed via the
// orig method which is the require for previous bundles
parcelRequire = (function (modules, cache, entry, globalName) {
  // Save the require from previous bundle to this closure if any
  var previousRequire = typeof parcelRequire === 'function' && parcelRequire;
  var nodeRequire = typeof require === 'function' && require;

  function newRequire(name, jumped) {
    if (!cache[name]) {
      if (!modules[name]) {
        // if we cannot find the module within our internal map or
        // cache jump to the current global require ie. the last bundle
        // that was added to the page.
        var currentRequire = typeof parcelRequire === 'function' && parcelRequire;
        if (!jumped && currentRequire) {
          return currentRequire(name, true);
        }

        // If there are other bundles on this page the require from the
        // previous one is saved to 'previousRequire'. Repeat this as
        // many times as there are bundles until the module is found or
        // we exhaust the require chain.
        if (previousRequire) {
          return previousRequire(name, true);
        }

        // Try the node require function if it exists.
        if (nodeRequire && typeof name === 'string') {
          return nodeRequire(name);
        }

        var err = new Error('Cannot find module \'' + name + '\'');
        err.code = 'MODULE_NOT_FOUND';
        throw err;
      }

      localRequire.resolve = resolve;
      localRequire.cache = {};

      var module = cache[name] = new newRequire.Module(name);

      modules[name][0].call(module.exports, localRequire, module, module.exports, this);
    }

    return cache[name].exports;

    function localRequire(x){
      return newRequire(localRequire.resolve(x));
    }

    function resolve(x){
      return modules[name][1][x] || x;
    }
  }

  function Module(moduleName) {
    this.id = moduleName;
    this.bundle = newRequire;
    this.exports = {};
  }

  newRequire.isParcelRequire = true;
  newRequire.Module = Module;
  newRequire.modules = modules;
  newRequire.cache = cache;
  newRequire.parent = previousRequire;
  newRequire.register = function (id, exports) {
    modules[id] = [function (require, module) {
      module.exports = exports;
    }, {}];
  };

  var error;
  for (var i = 0; i < entry.length; i++) {
    try {
      newRequire(entry[i]);
    } catch (e) {
      // Save first error but execute all entries
      if (!error) {
        error = e;
      }
    }
  }

  if (entry.length) {
    // Expose entry point to Node, AMD or browser globals
    // Based on https://github.com/ForbesLindesay/umd/blob/master/template.js
    var mainExports = newRequire(entry[entry.length - 1]);

    // CommonJS
    if (typeof exports === "object" && typeof module !== "undefined") {
      module.exports = mainExports;

    // RequireJS
    } else if (typeof define === "function" && define.amd) {
     define(function () {
       return mainExports;
     });

    // <script>
    } else if (globalName) {
      this[globalName] = mainExports;
    }
  }

  // Override the current require with this new one
  parcelRequire = newRequire;

  if (error) {
    // throw error from earlier, _after updating parcelRequire_
    throw error;
  }

  return newRequire;
})({"../src/core.ts":[function(require,module,exports) {
"use strict";

var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
var CustomTagName = 'span';
var HighLightClass = 'qoxop_highlight';
/**
 * 获取首尾节点的字符串，用于校验标记是否作废
 * @param start
 * @param end
 */

function countStartEndChunk(start, end) {
  return ("" + start.nodeValue + end.nodeValue).trim();
}
/**
 * 查询node下的所有文本节点
 * @param {Node} node
 */


function QueryAllTextNodes(node) {
  var texts = [];

  if (node) {
    if (document.createNodeIterator) {
      var textIterator = document.createNodeIterator(node, NodeFilter.SHOW_TEXT);
      var textNode = textIterator.nextNode();

      while (textNode) {
        texts.push(textNode);
        textNode = textIterator.nextNode();
      }

      return texts;
    } else {
      for (var i = 0; i < node.childNodes.length; i++) {
        if (node.childNodes[i].hasChildNodes()) {
          texts.push.apply(texts, QueryAllTextNodes(node.childNodes[i]));
        } else if (node.childNodes[i].nodeType === Node.TEXT_NODE) {
          texts.push(node.childNodes[i]);
        }
      }
    }
  }

  return texts;
}
/**
 * 计算选中文本在文档中的位置
 */


function countSelectionInfo() {
  var selection = window.getSelection();

  if (!selection.isCollapsed) {
    var range = selection.getRangeAt(0);
    var startOffset = range.startOffset,
        endOffset = range.endOffset;
    var selectionInfo = {
      id: window.btoa("" + Date.now() * Math.random() + (Math.random() * 100).toFixed(2)),
      container: {
        index: -1,
        tagname: ''
      },
      textNodes: {
        start: null,
        end: null,
        startEndChunk: ''
      },
      href: window.location.href,
      time: Date.now(),
      text: selection.toString()
    }; // 寻找容器元素

    var containerElem = range.commonAncestorContainer;

    while (true) {
      if (containerElem.nodeType === Node.ELEMENT_NODE || !containerElem) {
        break;
      }

      containerElem = containerElem.parentElement;
    } // 记住node位置            


    var allTextNodes = QueryAllTextNodes(containerElem);

    for (var i = 0; i < allTextNodes.length; i++) {
      if (allTextNodes[i] === range.startContainer) {
        selectionInfo.textNodes.start = {
          index: i,
          split: startOffset
        };
      }

      if (allTextNodes[i] === range.endContainer) {
        selectionInfo.textNodes.end = {
          index: i,
          split: endOffset
        };
        break;
      }
    }

    selectionInfo.textNodes.all = allTextNodes;
    selectionInfo.textNodes.startEndChunk = countStartEndChunk(range.startContainer, range.endContainer); // 记住元素位置

    var tags = document.getElementsByTagName(containerElem.nodeName);

    for (var i = 0; i < tags.length; i++) {
      if (tags.item(i) === containerElem) {
        selectionInfo.container.index = i;
        selectionInfo.container.tagname = containerElem.nodeName;
        selectionInfo.container.elem = containerElem;
        break;
      }
    }

    selection.removeAllRanges();
    return selectionInfo;
  }

  return false;
}

exports.countSelectionInfo = countSelectionInfo;
/**
 * 渲染标记文本
 * @param MarkInfo
 */

function render(mark) {
  var _a = mark.container,
      tagIndex = _a.index,
      tagname = _a.tagname,
      _b = mark.textNodes,
      start = _b.start,
      end = _b.end;
  var elem = mark.container.elem,
      allTexts = mark.textNodes.all;
  var Wrp = document.createElement(CustomTagName);
  var className = HighLightClass + " " + (mark.className ? mark.className : '');
  Wrp.setAttribute('class', (mark.unused ? '' : className) + " " + mark.id);
  Wrp.setAttribute('mark_id', mark.id);

  if (mark.style) {
    Object.keys(mark.style).forEach(function (key) {
      // @ts-ignore
      Wrp.style[key] = mark.style[key];
    });
  }

  if (mark.meta) {
    Wrp.setAttribute('meta_data', JSON.stringify(mark.meta));
  }

  if (!allTexts || allTexts.length < 1) {
    if (!(elem instanceof Element)) {
      var elems = document.getElementsByTagName(tagname);
      elem = elems.item(tagIndex);
    }

    allTexts = QueryAllTextNodes(elem); // check chunk

    if (allTexts && allTexts[start.index] && allTexts[end.index]) {
      var startEndChunk = countStartEndChunk(allTexts[start.index], allTexts[end.index]);

      if (mark.textNodes.startEndChunk !== startEndChunk) {
        return false;
      }
    } else {
      return false;
    }
  }

  var WrpFn = function WrpFn(text) {
    var wrp = Wrp.cloneNode();
    wrp.innerHTML = text.nodeValue;
    text.parentNode.replaceChild(wrp, text);
  };

  try {
    if (start.index === end.index) {
      var nextText = allTexts[start.index].splitText(start.split).splitText(end.split - start.split);
      WrpFn(nextText.previousSibling);
      return true;
    }

    for (var i = start.index + 1; i < end.index; i++) {
      WrpFn(allTexts[i]);
    }

    var startText = allTexts[start.index].splitText(start.split);
    var endText = allTexts[end.index].splitText(end.split).previousSibling;
    WrpFn(startText);
    WrpFn(endText);
    return true;
  } catch (error) {
    console.error(error);
    return false;
  }
}

exports.render = render;

var _a = function () {
  var afns = [];
  return {
    setAfterMark: function setAfterMark(fn) {
      afns.push(fn);
    },
    runAfters: function runAfters(mi) {
      afns.reduce(function (old, fn) {
        return fn(mi, old);
      }, null);
    }
  };
}(),
    setAfterMark = _a.setAfterMark,
    runAfters = _a.runAfters;

exports.setAfterMark = setAfterMark;

var setMarkTagName = function setMarkTagName(tagname) {
  return CustomTagName = tagname;
};

exports.setMarkTagName = setMarkTagName;

var setDefaultClass = function setDefaultClass(className) {
  return HighLightClass = className;
};

exports.setDefaultClass = setDefaultClass;

function default_1(options, callback) {
  if (options === void 0) {
    options = {};
  }

  var info = countSelectionInfo();
  var success = false;

  if (info !== false) {
    var mi = __assign(__assign({}, info), options);

    success = render(mi);

    if (success) {
      runAfters(mi);
    }

    if (typeof callback === 'function') {
      callback(mi, success);
    }
  }

  return success;
}

exports.default = default_1;
},{}],"../src/localManager.ts":[function(require,module,exports) {
"use strict";

var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var core_1 = require("./core");

var pageHashPrefix = 'qoxop_mark_';
var config = {
  pageHashPrefix: pageHashPrefix,
  pageHash: function pageHash(href) {
    return pageHashPrefix + href.replace(location.origin, '');
  },
  getPageInfo: function getPageInfo() {
    return {
      title: document.title
    };
  }
};
var MarkStore = {};
/**
 *  清除页面副作用
 * @param marks
 */

function clearDomSideEffect(marks) {
  marks.reverse().forEach(function (item) {
    var domArray = Array.from(document.getElementsByClassName(item.id) || []);
    domArray.forEach(function (elem) {
      return elem.replaceWith(elem.firstChild);
    });
  });
  document.normalize();
}
/**
 * 获取当前页面的所有标记
 */


function getCurrentPageMarks() {
  var pageHash = config.pageHash,
      getPageInfo = config.getPageInfo;
  var hash = pageHash(window.location.href);

  if (!MarkStore[hash]) {
    MarkStore[hash] = JSON.parse(window.localStorage.getItem(hash)) || {
      marks: [],
      pageInfo: getPageInfo()
    };
  }

  return MarkStore[hash];
}
/**
 * 设置配置项
 * @param options
 */


function setConfig(options) {
  if (options === void 0) {
    options = {};
  }

  var obj = Object.assign({
    markTagName: 'span',
    defaultClassName: 'qoxop_highlight'
  }, options);
  Object.keys(obj).forEach(function (key) {
    var value = obj[key];

    if (key === 'markTagName') {
      core_1.setMarkTagName(value);
    } else if (key === 'defaultClassName') {
      core_1.setDefaultClass(value);
    } else {
      config[key] = value;
    }
  });
  pageHashPrefix = config.pageHashPrefix;
  return config;
}

exports.setConfig = setConfig;
/**
 * 渲染当前页的所有标记
 */

function renderAll() {
  document.normalize();
  var allmarks = getCurrentPageMarks();

  if (!allmarks || !allmarks.marks || allmarks.marks.length === 0) {
    return true;
  }

  var elems = document.getElementsByClassName(allmarks.marks[0].id);

  if (elems && elems.length > 0) {
    return true;
  }

  if (!allmarks.marks.every(function (item) {
    return core_1.render(item);
  })) {
    removeAll({
      domain: false,
      retainTexts: true
    });
  }

  return true;
}

exports.renderAll = renderAll;
/**
 * 移除标记
 * @param id
 * @param allRmHandler
 */

function remove(id, allRmHandler) {
  var allMarks = getCurrentPageMarks();
  allMarks.marks.some(function (item) {
    if (id === item.id && !item.unused) {
      var elems = document.getElementsByClassName(id); // 删除class

      var elemArr = Array.prototype.slice.call(elems);
      elemArr.forEach(function (elem) {
        return elem.setAttribute('class', id);
      });
      item.unused = true;
      return true;
    }
  });

  if (allMarks.marks.every(function (item) {
    return item.unused;
  })) {
    if (allRmHandler) {
      allRmHandler(function () {
        allMarks.marks = [];
        removeAll({
          domain: false,
          retainTexts: false
        });
      }, allMarks.marks);
    } else {
      removeAll({
        domain: false,
        retainTexts: false
      });
    }
  } else {
    var pageHash = config.pageHash;
    var hash = pageHash(window.location.href);
    window.localStorage.setItem(hash, JSON.stringify(allMarks));
  }
}

exports.remove = remove;
/**
 * 标记文本查询
 */

var query = {
  marks: function marks() {
    return Object.keys(localStorage).filter(function (key) {
      return key.indexOf(pageHashPrefix) === 0;
    }).reduce(function (dateset, key) {
      var _a;

      return __assign(__assign({}, dateset), (_a = {}, _a[key] = JSON.parse(localStorage[key]), _a));
    }, {});
  },
  texts: function texts(includeHistory) {
    var historys = {};

    if (includeHistory) {
      historys = Object.keys(localStorage).filter(function (key) {
        return key.indexOf("history_" + pageHashPrefix + "_") === 0;
      }).reduce(function (dateset, key) {
        var _a;

        return __assign(__assign({}, dateset), (_a = {}, _a[key] = JSON.parse(localStorage[key]), _a));
      }, {});
    }

    var marks = query.marks();
    return Object.keys(marks).reduce(function (dataset, key) {
      var _a;

      return __assign(__assign({}, dataset), (_a = {}, _a[key] = marks[key].marks.map(function (m) {
        return m.text;
      }), _a));
    }, historys);
  }
};
exports.query = query;
/**
 * 清除所有标记
 * @param params
 */

function removeAll(options) {
  if (options === void 0) {
    options = {};
  }

  var _a = __assign({
    domain: false,
    retainTexts: false
  }, options),
      domain = _a.domain,
      retainTexts = _a.retainTexts;

  var pageHash = config.pageHash(window.location.href);
  var markSet = [];
  Object.keys(localStorage).filter(function (key) {
    if (domain === true) {
      return key.indexOf(pageHashPrefix) === 0;
    } else {
      return key === pageHash;
    }
  }).forEach(function (key) {
    try {
      var marks = JSON.parse(localStorage.getItem(key) || '{}').marks;
      markSet = markSet.concat(marks);

      if (retainTexts) {
        // 保存文本备份
        var historys = JSON.parse(localStorage.getItem("history_" + pageHashPrefix) || '[]');
        localStorage.setItem("history_" + pageHashPrefix, JSON.stringify(historys.concat(marks.map(function (item) {
          return item.text;
        }))));
      }
    } catch (error) {
      console.error(error);
    }

    localStorage.removeItem(key);
    delete MarkStore[key];
  }); // 清除页面副作用的方式

  clearDomSideEffect(markSet);
}

exports.removeAll = removeAll;
/**
 * 标记后存储
 */

core_1.setAfterMark(function (mi) {
  var pageHash = config.pageHash,
      getPageInfo = config.getPageInfo;
  var hash = pageHash(mi.href);
  var storeMi = mi;
  delete storeMi.textNodes.all;
  delete storeMi.container.elem;

  if (!MarkStore[hash]) {
    MarkStore[hash] = {
      marks: [storeMi],
      pageInfo: getPageInfo()
    };
  } else {
    MarkStore[hash].marks.push(storeMi);
  }

  window.localStorage.setItem(hash, JSON.stringify(MarkStore[hash]));
});
},{"./core":"../src/core.ts"}],"../src/index.ts":[function(require,module,exports) {
"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var core_1 = __importDefault(require("./core"));

exports.mark = core_1.default;

var localManager_1 = require("./localManager");

exports.setConfig = localManager_1.setConfig;
exports.remove = localManager_1.remove;
exports.removeAll = localManager_1.removeAll;
exports.renderAll = localManager_1.renderAll;
exports.query = localManager_1.query;
var DOMContentLoaded = new Promise(function (resolve) {
  window.addEventListener('DOMContentLoaded', function () {
    var styleElement = document.createElement('style');
    styleElement.innerHTML = ".qoxop_highlight {background: #f3f308;}";
    document.head.appendChild(styleElement);
    setTimeout(function () {
      resolve();
    }, 10);
  });
});

function init(options) {
  if (options === void 0) {
    options = {};
  }

  var config = localManager_1.setConfig(options);
  var pageId = config.pageHash(window.location.href);
  var immediate = options.immediate,
      onUrlChange = options.onUrlChange,
      _a = options.delay,
      delay = _a === void 0 ? 500 : _a;
  var cancelKey = 0;

  if (immediate) {
    DOMContentLoaded.then(localManager_1.renderAll);
  }

  if (onUrlChange) {
    var observer = new MutationObserver(function () {
      if (cancelKey !== 0) {
        clearTimeout(cancelKey);
      } // @ts-ignore


      cancelKey = setTimeout(function () {
        cancelKey = 0;
        var newPageId = config.pageHash(window.location.href);

        if (pageId !== newPageId) {
          pageId = newPageId;
          localManager_1.renderAll();
        }
      }, delay);
    });
    observer.observe(document.body, {
      childList: true,
      subtree: true
    });
  }
}

exports.init = init;
},{"./core":"../src/core.ts","./localManager":"../src/localManager.ts"}],"test.js":[function(require,module,exports) {
"use strict";

var webmark = _interopRequireWildcard(require("../src/index"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

window.addEventListener('load', function () {
  window.webmark = webmark;
  webmark.init({
    immediate: true
  });
  var tipsBar = document.getElementById('mark_tips_bar');
  var tipsBarShowing = false;
  var curSelection = null;
  window.addEventListener('mouseup', function (event) {
    curSelection = window.getSelection();

    if (!curSelection.isCollapsed && !tipsBarShowing) {
      tipsBarShowing = true;
      tipsBar.style.display = 'inline-flex';
      tipsBar.style.top = "".concat(event.clientY, "px");
      tipsBar.style.left = "".concat(event.clientX, "px");
    } else {
      tipsBarShowing = false;
      tipsBar.style.display = 'none';
    }
  });

  tipsBar.onmousedown = function (event) {
    event.preventDefault();
    tipsBarShowing = false;
    tipsBar.style.display = 'none';
    console.log(webmark.mark({
      className: event.target.getAttribute('class'),
      selection: curSelection
    }));
  };
});
},{"../src/index":"../src/index.ts"}],"../../../.config/yarn/global/node_modules/parcel-bundler/src/builtins/hmr-runtime.js":[function(require,module,exports) {
var global = arguments[3];
var OVERLAY_ID = '__parcel__error__overlay__';
var OldModule = module.bundle.Module;

function Module(moduleName) {
  OldModule.call(this, moduleName);
  this.hot = {
    data: module.bundle.hotData,
    _acceptCallbacks: [],
    _disposeCallbacks: [],
    accept: function (fn) {
      this._acceptCallbacks.push(fn || function () {});
    },
    dispose: function (fn) {
      this._disposeCallbacks.push(fn);
    }
  };
  module.bundle.hotData = null;
}

module.bundle.Module = Module;
var checkedAssets, assetsToAccept;
var parent = module.bundle.parent;

if ((!parent || !parent.isParcelRequire) && typeof WebSocket !== 'undefined') {
  var hostname = "" || location.hostname;
  var protocol = location.protocol === 'https:' ? 'wss' : 'ws';
  var ws = new WebSocket(protocol + '://' + hostname + ':' + "55191" + '/');

  ws.onmessage = function (event) {
    checkedAssets = {};
    assetsToAccept = [];
    var data = JSON.parse(event.data);

    if (data.type === 'update') {
      var handled = false;
      data.assets.forEach(function (asset) {
        if (!asset.isNew) {
          var didAccept = hmrAcceptCheck(global.parcelRequire, asset.id);

          if (didAccept) {
            handled = true;
          }
        }
      }); // Enable HMR for CSS by default.

      handled = handled || data.assets.every(function (asset) {
        return asset.type === 'css' && asset.generated.js;
      });

      if (handled) {
        console.clear();
        data.assets.forEach(function (asset) {
          hmrApply(global.parcelRequire, asset);
        });
        assetsToAccept.forEach(function (v) {
          hmrAcceptRun(v[0], v[1]);
        });
      } else if (location.reload) {
        // `location` global exists in a web worker context but lacks `.reload()` function.
        location.reload();
      }
    }

    if (data.type === 'reload') {
      ws.close();

      ws.onclose = function () {
        location.reload();
      };
    }

    if (data.type === 'error-resolved') {
      console.log('[parcel] ✨ Error resolved');
      removeErrorOverlay();
    }

    if (data.type === 'error') {
      console.error('[parcel] 🚨  ' + data.error.message + '\n' + data.error.stack);
      removeErrorOverlay();
      var overlay = createErrorOverlay(data);
      document.body.appendChild(overlay);
    }
  };
}

function removeErrorOverlay() {
  var overlay = document.getElementById(OVERLAY_ID);

  if (overlay) {
    overlay.remove();
  }
}

function createErrorOverlay(data) {
  var overlay = document.createElement('div');
  overlay.id = OVERLAY_ID; // html encode message and stack trace

  var message = document.createElement('div');
  var stackTrace = document.createElement('pre');
  message.innerText = data.error.message;
  stackTrace.innerText = data.error.stack;
  overlay.innerHTML = '<div style="background: black; font-size: 16px; color: white; position: fixed; height: 100%; width: 100%; top: 0px; left: 0px; padding: 30px; opacity: 0.85; font-family: Menlo, Consolas, monospace; z-index: 9999;">' + '<span style="background: red; padding: 2px 4px; border-radius: 2px;">ERROR</span>' + '<span style="top: 2px; margin-left: 5px; position: relative;">🚨</span>' + '<div style="font-size: 18px; font-weight: bold; margin-top: 20px;">' + message.innerHTML + '</div>' + '<pre>' + stackTrace.innerHTML + '</pre>' + '</div>';
  return overlay;
}

function getParents(bundle, id) {
  var modules = bundle.modules;

  if (!modules) {
    return [];
  }

  var parents = [];
  var k, d, dep;

  for (k in modules) {
    for (d in modules[k][1]) {
      dep = modules[k][1][d];

      if (dep === id || Array.isArray(dep) && dep[dep.length - 1] === id) {
        parents.push(k);
      }
    }
  }

  if (bundle.parent) {
    parents = parents.concat(getParents(bundle.parent, id));
  }

  return parents;
}

function hmrApply(bundle, asset) {
  var modules = bundle.modules;

  if (!modules) {
    return;
  }

  if (modules[asset.id] || !bundle.parent) {
    var fn = new Function('require', 'module', 'exports', asset.generated.js);
    asset.isNew = !modules[asset.id];
    modules[asset.id] = [fn, asset.deps];
  } else if (bundle.parent) {
    hmrApply(bundle.parent, asset);
  }
}

function hmrAcceptCheck(bundle, id) {
  var modules = bundle.modules;

  if (!modules) {
    return;
  }

  if (!modules[id] && bundle.parent) {
    return hmrAcceptCheck(bundle.parent, id);
  }

  if (checkedAssets[id]) {
    return;
  }

  checkedAssets[id] = true;
  var cached = bundle.cache[id];
  assetsToAccept.push([bundle, id]);

  if (cached && cached.hot && cached.hot._acceptCallbacks.length) {
    return true;
  }

  return getParents(global.parcelRequire, id).some(function (id) {
    return hmrAcceptCheck(global.parcelRequire, id);
  });
}

function hmrAcceptRun(bundle, id) {
  var cached = bundle.cache[id];
  bundle.hotData = {};

  if (cached) {
    cached.hot.data = bundle.hotData;
  }

  if (cached && cached.hot && cached.hot._disposeCallbacks.length) {
    cached.hot._disposeCallbacks.forEach(function (cb) {
      cb(bundle.hotData);
    });
  }

  delete bundle.cache[id];
  bundle(id);
  cached = bundle.cache[id];

  if (cached && cached.hot && cached.hot._acceptCallbacks.length) {
    cached.hot._acceptCallbacks.forEach(function (cb) {
      cb();
    });

    return true;
  }
}
},{}]},{},["../../../.config/yarn/global/node_modules/parcel-bundler/src/builtins/hmr-runtime.js","test.js"], null)
//# sourceMappingURL=/test.e98b79dd.js.map